#!/usr/bin/perl

use v5.10;
use strict;
use warnings;

#undef $/;
#$_ = <>;

my $URL = $ARGV[0];
$_ = qx(curl -s -S --url $URL) or 
     die "Couldn't download URL: $URL\nStopped";

s#\A.*?<div class="table-container">(.*?)</tbody>.+\Z#$1#ms;
s#<a href[^>]+>#<A>#g;
s#<span> / </span>#; #g;

$, = "\t";

while (
    s%\s*<td\ class="tracknum">(\d+)
      .*?<div\ class="title">\s*<A>\s*(.+?)\s*</a>\s*</div>
      .*?<div\ class="artist\ secondary_link">\s*(.*?)\s*</div>
      .*?<td\ class="performer\ secondary_link">.+?<div\ class="primary">\s*(.+?)\s*</div>
      (?:.*?<span\ class="featuring">(.+?)</span>)?
     %%xms)
{

    my ($track, $name, $composer, $performer, $featuring) = ($1, $2, $3, $4, $5 || undef);

    say $track, $name, clean($composer), clean($performer), $featuring ? clean($featuring) : '';
}

sub clean {
    local $_ = shift;
    s/[\n\r]//g;
    s/<A>//g;
    s/<\/a>//g;
    s/feat. //;
    return $_;
}
